/* Results from GetVersion

   Environment   LOWORD                 HIWORD
   -------------------------------------------------------

   Windows 3.x   Windows version        MS-DOS version
   WFW           Windows version 3.1    MS-DOS version
   WOW           Windows version 3.1    MS-DOS version 5.0
   Windows 95    Windows version 3.95   MS-DOS version 7.0
   Win95 OSR2    Windows version 3.95   MS-DOS version 7.10
   Windows 98    Windows version 3.95   MS-DOS version 7.10
*/

#include "windows.h"            /* required for all Windows applications */
#include "getverrs.h"           /* Resources header */

 
/* Constants for GetWinFlags. */

  #define WF_PMODE       0x0001
  #define WF_CPU286      0x0002
  #define WF_CPU386      0x0004
  #define WF_CPU486      0x0008
  #define WF_STANDARD    0x0010
  #define WF_WIN286      0x0010
  #define WF_ENHANCED    0x0020
  #define WF_WIN386      0x0020
  #define WF_CPU086      0x0040
  #define WF_CPU186      0x0080
  #if (WINVER < 0x030a)
  #define WF_LARGEFRAME  0x0100
  #define WF_SMALLFRAME  0x0200
  #else
  #define WF_CPUR4000             0x0100 /* MIPS R4000 */
  #define WF_CPUALPHA21064        0x0200 /* Alpha 21064 */
  #endif
  #define WF_80x87        0x0400
  #define WF_PAGING       0x0800
  #define WF_DOSPAGING    0x1000
  #define WF_HASCPUID     0x2000
  #define WF_WINNT        0x4000
  #define WF_WLO          0x8000  /* Windows on OS/2 */
  #define WF_CPUMASK      0xFC000000
  #define WF_CPU_X86      0
  #define WF_CPU_R4000    1
  #define WF_CPU_ALPHA    2
  #define WF_CPU_CLIPPER  3
 
int FAR PASCAL DialogProc( HWND hDlg, UINT message,
                           WPARAM wParam, LPARAM lParam )
{
   DWORD dwWinFlags;
   DWORD dwVersion;
   char Message[1000];

   switch ( message )
   {
   case WM_INITDIALOG:

      dwWinFlags = GetWinFlags();
      dwVersion = GetVersion();
      
      wsprintf(Message,
               "Windows version %d.%d, DOS version %d.%d\r\nWinFlags %lX\r\n",
               LOBYTE(LOWORD(dwVersion)), HIBYTE(LOWORD(dwVersion)),
               HIBYTE(HIWORD(dwVersion)), LOBYTE(HIWORD(dwVersion)),
               dwWinFlags);
      if ( (dwWinFlags & WF_PMODE) == WF_PMODE )
         lstrcat( Message, "   Protected mode\r\n" );

      if ( (dwWinFlags & WF_CPU286) == WF_CPU286 )
         lstrcat( Message, "   80286 CPU\r\n" );

      if ( (dwWinFlags & WF_CPU386) == WF_CPU386 )
         lstrcat( Message, "   80386 CPU\r\n" );

      if ( (dwWinFlags & WF_CPU486) == WF_CPU486 )
         lstrcat( Message, "   80486 CPU\r\n" );

      if ( (dwWinFlags & WF_STANDARD) == WF_STANDARD )
         lstrcat( Message, "   Standard mode\r\n" );

      if ( (dwWinFlags & WF_ENHANCED) == WF_ENHANCED )
         lstrcat( Message, "   Enhanced mode\r\n" );

      if ( (dwWinFlags & WF_CPU086) == WF_CPU086 )
         lstrcat( Message, "   80086 CPU\r\n" );

      if ( (dwWinFlags & WF_CPU186) == WF_PMODE )
         lstrcat( Message, "   80186 CPU\r\n" );

      if ( (dwWinFlags & WF_CPUR4000) == WF_CPUR4000 )
         lstrcat( Message, "   MIPS R4000 CPU\r\n" );

      if ( (dwWinFlags & WF_CPUALPHA21064) == WF_CPUALPHA21064 )
         lstrcat( Message, "   Alpha 21064 CPU\r\n" );

      if ( (dwWinFlags & WF_80x87) == WF_80x87 )
         lstrcat( Message, "   80x87 co-processor present\r\n" );

      if ( (dwWinFlags & WF_PAGING) == WF_PAGING )
         lstrcat( Message, "   Paging\r\n" );

      if ( (dwWinFlags & WF_DOSPAGING) == WF_DOSPAGING )
         lstrcat( Message, "   DOS Paging\r\n" );

      if ( (dwWinFlags & WF_HASCPUID) == WF_HASCPUID )
         lstrcat( Message, "   CPU has ID\r\n" );

      if ( (dwWinFlags & WF_WINNT) == WF_WINNT )
         lstrcat( Message, "   Windows NT\r\n" );

      if ( (dwWinFlags & WF_WLO) == WF_WLO )
         lstrcat( Message, "   Windows on OS/2\r\n" );

      SetDlgItemText( hDlg, ID_VERSION, Message );
      return TRUE;

   case WM_COMMAND:
      switch ( LOWORD(wParam) )
      {
      case ID_COPY:
         SendDlgItemMessage( hDlg, ID_VERSION, EM_SETSEL, 0, MAKELONG(0,-1) );
         SendDlgItemMessage( hDlg, ID_VERSION, WM_COPY, 0, 0 );
         SendDlgItemMessage( hDlg, ID_VERSION, EM_SETSEL, 0, MAKELONG(0,0) );
         return TRUE;

      case IDOK:
      case IDCANCEL:
         EndDialog( hDlg, 0 );
         return TRUE;

      default:
         break;
      }
      return FALSE;

   default:
      return FALSE;
   }
}

/****************************************************************************/

int PASCAL WinMain( HANDLE hInstance, HANDLE hPrevInstance,
                    LPSTR lpCmdLine, int nCmdShow)
{
   DialogBox(hInstance, "GET_VERSION", NULL, (DLGPROC)DialogProc );
   return 0;
}

